.386
.model	flat,stdcall
option	casemap:none
include \masm32\include\comctl32.inc
includelib \masm32\lib\comctl32.lib
include \masm32\include\debug.inc
includelib \masm32\lib\debug.lib
include		demo.inc

.code
start:
	invoke GetModuleHandle, NULL
	mov hInstance,eax
	invoke GetCommandLine
	
	mov	iccex.dwSize,sizeof(INITCOMMONCONTROLSEX)
	mov	iccex.dwICC,ICC_BAR_CLASSES or ICC_WIN95_CLASSES
	invoke InitCommonControlsEx,addr iccex
	invoke DialogBoxParam,hInstance,1001,0,addr DlgProc,0
	invoke ExitProcess,eax
;=====================================================================

DlgProc	proc hWnd:HWND,iMsg:DWORD,wParam:WPARAM, lParam:LPARAM

    LOCAL BtnStruct :XXBUTTON
    LOCAL hBtn      :HWND
	
	.if	iMsg == WM_INITDIALOG

        invoke memfill, ADDR BtnStruct, sizeof(XXBUTTON), 0 ; BtnStruct set null

;========================Exit=========================================		
		mov BtnStruct.dwStyle, BTN_NORMAL
		mov BtnStruct.hIcon_normal, $invoke ( LoadIcon, hInstance, IDI_EXIT )
		mov BtnStruct.hIcon_hover, FALSE
		mov BtnStruct.m_flat, FALSE
		mov BtnStruct.m_IconAlign, BS_LEFT
		mov BtnStruct.m_border, TRUE
		mov hBtn, $invoke ( GetDlgItem, hWnd, IDC_EXIT )
		invoke RedrawButton, hBtn, ADDR BtnStruct
;========================About========================================		
		mov BtnStruct.hIcon_normal, $invoke ( LoadIcon, hInstance, IDI_ABOUT )
		mov BtnStruct.m_flat, TRUE
		invoke LoadCursor, NULL, IDC_HAND
		mov BtnStruct.hCursor_hover, eax
		mov hBtn, $invoke ( GetDlgItem, hWnd, IDC_ABOUT )
		invoke RedrawButton, hBtn, ADDR BtnStruct
;========================Left Icon ===================================		
		mov BtnStruct.hIcon_normal, $invoke ( LoadIcon, hInstance, IDI_OK )
		mov BtnStruct.m_flat, FALSE
		mov BtnStruct.m_IconAlign, BS_LEFT
		mov BtnStruct.hCursor_hover, 0
		mov hBtn, $invoke ( GetDlgItem, hWnd, IDC_BUTTONLEFT )
		invoke RedrawButton, hBtn, ADDR BtnStruct
;========================Right Icon====================================		
		mov BtnStruct.m_IconAlign, BS_RIGHT
		mov hBtn, $invoke ( GetDlgItem, hWnd, IDC_BUTTONRIGHT )
		invoke RedrawButton, hBtn, ADDR BtnStruct
;========================Top Icon======================================		
		mov BtnStruct.hIcon_normal, $invoke ( LoadIcon, hInstance, IDI_CANSEL )
		mov BtnStruct.m_IconAlign, BS_TOP
		mov hBtn, $invoke ( GetDlgItem, hWnd, IDC_BUTTONTOP )
		invoke RedrawButton, hBtn, ADDR BtnStruct						
;========================Only Icon - Left==============================		
		mov BtnStruct.hIcon_normal, $invoke ( LoadIcon, hInstance, IDI_LEFT )
		mov BtnStruct.m_flat, TRUE
		mov hBtn, $invoke ( GetDlgItem, hWnd, IDC_SLEFT )
		invoke RedrawButton, hBtn, ADDR BtnStruct
;========================Only Icon - Right=============================		
		mov BtnStruct.hIcon_normal, $invoke ( LoadIcon, hInstance, IDI_RIGHT )
		mov hBtn, $invoke ( GetDlgItem, hWnd, IDC_SRIGHT )
		invoke RedrawButton, hBtn, ADDR BtnStruct
;========================Only Text=====================================		
		mov BtnStruct.hIcon_normal, 0
		mov hBtn, $invoke ( GetDlgItem, hWnd, IDC_TEXT )
		invoke RedrawButton, hBtn, ADDR BtnStruct		
;========================Disabled======================================		
		mov BtnStruct.hIcon_normal, $invoke ( LoadIcon, hInstance, IDI_OK )
		mov BtnStruct.m_flat, FALSE
		mov BtnStruct.m_IconAlign, BS_LEFT
		mov hBtn, $invoke ( GetDlgItem, hWnd, IDC_DISABLED )
		invoke RedrawButton, hBtn, ADDR BtnStruct
;========================Flat Disabled=================================		
		mov BtnStruct.hIcon_normal, $invoke ( LoadIcon, hInstance, IDI_OK )
		mov BtnStruct.m_flat, TRUE
		mov BtnStruct.m_IconAlign, BS_TOP
		mov hBtn, $invoke ( GetDlgItem, hWnd, IDC_FLATDISABLED )
		invoke RedrawButton, hBtn, ADDR BtnStruct			
;========================Lamp Flat=====================================		
		mov BtnStruct.hIcon_normal, $invoke ( LoadIcon, hInstance, IDI_LAMP2 )
		mov BtnStruct.hIcon_hover, $invoke ( LoadIcon, hInstance, IDI_LAMP1 )
		mov BtnStruct.m_flat, TRUE
		mov hBtn, $invoke ( GetDlgItem, hWnd, IDC_LAMP )
		invoke RedrawButton, hBtn, ADDR BtnStruct			
;========================Lamp2=========================================		
		mov BtnStruct.hIcon_normal, $invoke ( LoadIcon, hInstance, IDI_LAMP2 )
		mov BtnStruct.hIcon_hover, $invoke ( LoadIcon, hInstance, IDI_LAMP1 )
		mov BtnStruct.m_border, FALSE
		mov hBtn, $invoke ( GetDlgItem, hWnd, IDC_LAMP2 )
		invoke RedrawButton, hBtn, ADDR BtnStruct
			
;========================Light Text ===================================		
		mov BtnStruct.hIcon_normal, NULL
		mov BtnStruct.hIcon_hover, NULL
		mov BtnStruct.m_border, TRUE
		mov BtnStruct.m_IconAlign, BS_LEFT
		
		RGB 0, 0, 255
		mov BtnStruct.hover_clr, eax
		RGB 128, 128, 0
		mov BtnStruct.push_clr, eax		
		RGB 128, 0, 96
		mov BtnStruct.normal_clr, eax
		
		mov hBtn, $invoke ( GetDlgItem, hWnd, IDC_NTEXT )
		invoke RedrawButton, hBtn, ADDR BtnStruct
;========================Link==========================================		
		mov BtnStruct.hIcon_normal, NULL
		mov BtnStruct.hIcon_hover, NULL
		mov BtnStruct.m_border, FALSE
		
		invoke CreateFontIndirect, ADDR lgFnt
		mov hFnt, eax
		mov BtnStruct.hFont_normal, eax
		
		invoke CreateFontIndirect, ADDR lgFntFocus
   	    mov hFntFocus, eax
		mov BtnStruct.hFont_hover, eax	
		
		invoke LoadCursor, NULL, IDC_HAND
		mov BtnStruct.hCursor_hover, eax		
				
		invoke FindResource, NULL, IDW_HOVER, RT_RCDATA
		invoke LoadResource, NULL, eax
		mov BtnStruct.Sound_hover, eax
				
		mov hBtn, $invoke ( GetDlgItem, hWnd, IDC_LINK )
		invoke RedrawButton, hBtn, ADDR BtnStruct

	.elseif	iMsg == WM_CLOSE
	
   	    invoke DeleteObject, hFntFocus
    	invoke DeleteObject, hFnt
		invoke	EndDialog, hWnd, NULL
	
	.elseif iMsg == WM_COMMAND
		mov	eax,wParam
		mov	edx,eax
		shr	edx,16
		
		.if	dx == BN_CLICKED
			.if	eax == IDC_EXIT
				invoke	SendMessage, hWnd, WM_CLOSE, NULL, NULL
			.elseif	eax == IDC_LINK	
				invoke ShellExecute, 0, 0, ADDR email_chib, 0, 0, SW_SHOWNORMAL
			.endif
		.endif
	.else
		mov	eax,FALSE
		ret
	.endif
	
	mov	eax,TRUE
	ret
DlgProc endp

end start
